"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _construct2 = _interopRequireDefault(require("@babel/runtime/helpers/construct"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _reactCodemirror = _interopRequireDefault(require("@uiw/react-codemirror"));

var _copyToClipboard = _interopRequireDefault(require("@uiw/copy-to-clipboard"));

var _langJavascript = require("@codemirror/lang-javascript");

var _reactSplit = _interopRequireDefault(require("@uiw/react-split"));

var _ThirdPartyButton = _interopRequireDefault(require("./ThirdPartyButton"));

var icon = _interopRequireWildcard(require("./icon"));

var _transform = require("./transform");

var _ErrorMessage = require("./ErrorMessage");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["React", "ReactDOM"],
    _excluded2 = ["style", "prefixCls", "className", "editProps", "codePenOption", "codeSandboxOption", "code", "dependencies", "btnText", "btnHideText", "onlyEdit", "bordered", "noCode", "noPreview", "noScroll", "bgWhite"];

var CodePreview = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(CodePreview, _React$PureComponent);

  var _super = (0, _createSuper2.default)(CodePreview);

  function CodePreview(props) {
    var _this;

    (0, _classCallCheck2.default)(this, CodePreview);
    _this = _super.call(this, props);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "demoDom", /*#__PURE__*/_react.default.createRef());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "editor", /*#__PURE__*/_react.default.createRef());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "initHeight", 3);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "playerId", "".concat(parseInt(String(Math.random() * 1e9), 10).toString(36)));
    _this.state = {
      errorMessage: '',
      fullScreen: false,
      copied: false,
      showEdit: false,
      width: 1
    };
    return _this;
  }

  (0, _createClass2.default)(CodePreview, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this.props.noPreview) {
        this.executeCode(this.props.code);
      }

      window.addEventListener('popstate', function (e) {
        document.body.style.overflow = 'inherit';
      }, false);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.noPreview !== this.props.noPreview) {
        this.executeCode(prevProps.code);
      }
    }
  }, {
    key: "executeCode",
    value: function () {
      var _executeCode = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(codeStr) {
        var _this$props$dependenc, dependencies, _React, _ReactDOM, otherDeps, deps, args, argv, key, input, _babelTransform, code, message;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$props$dependenc = this.props.dependencies, dependencies = _this$props$dependenc === void 0 ? {} : _this$props$dependenc;
                _React = dependencies.React, _ReactDOM = dependencies.ReactDOM, otherDeps = (0, _objectWithoutProperties2.default)(dependencies, _excluded);

                try {
                  deps = (0, _objectSpread2.default)({
                    context: this,
                    React: _React || _react.default,
                    ReactDOM: _ReactDOM || _reactDom.default
                  }, otherDeps); // const args = ['context', 'React', 'ReactDOM', 'Component'];

                  args = []; // const argv = [this, React, ReactDOM, Component];

                  argv = [];

                  for (key in deps) {
                    args.push(key);
                    argv.push(deps[key]);
                  }

                  codeStr = codeStr.replace('_mount_', "document.getElementById('".concat(this.playerId, "')"));
                  input = "".concat(codeStr);
                  _babelTransform = (0, _transform.babelTransform)(input), code = _babelTransform.code;
                  args.push(code || ''); // console.log('code:', argv)
                  // eslint-disable-next-line no-new-func

                  (0, _construct2.default)(Function, args).apply(null, argv);
                  this.setState({
                    errorMessage: ''
                  });
                } catch (err) {
                  message = '';

                  if (err && err.message) {
                    message = err.message;
                  } else {
                    message = JSON.stringify(err);
                  }

                  this.setState({
                    errorMessage: message
                  });
                }

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function executeCode(_x) {
        return _executeCode.apply(this, arguments);
      }

      return executeCode;
    }()
    /**
     * onCopyCode
     */

  }, {
    key: "onCopyCode",
    value: function onCopyCode() {
      var _this2 = this;

      var code = this.props.code;
      (0, _copyToClipboard.default)(code || '', function (isCopy) {
        _this2.setState({
          copied: isCopy
        });
      });
      setTimeout(function () {
        _this2.setState({
          copied: false
        });
      }, 2000);
    }
    /**
     * onFullScreen
     */

  }, {
    key: "onFullScreen",
    value: function onFullScreen() {
      var _this3 = this;

      var fullScreen = this.state.fullScreen;
      this.setState({
        fullScreen: !fullScreen
      }, function () {
        document.body.style.overflow = !fullScreen ? 'hidden' : 'inherit';

        if (!fullScreen && _this3.demoDom.current) {
          _this3.demoDom.current.style.maxWidth = 'inherit';
        }
      });
    }
  }, {
    key: "initOldHeight",
    value: function initOldHeight() {
      var demo = this.demoDom.current;

      if (this.initHeight === 3 && demo) {
        this.initHeight = demo.clientHeight;
      }
    }
  }, {
    key: "handleChange",
    value: function handleChange(value, viewUpdate) {
      var editProps = this.props.editProps;
      this.executeCode(value);

      if (editProps && editProps.onChange) {
        editProps.onChange(value, viewUpdate);
      }
    }
    /**
     * onSwitchSource
     */

  }, {
    key: "onSwitchSource",
    value: function onSwitchSource() {
      var width = this.state.width;
      this.initOldHeight();
      this.setState({
        width: width === 1 ? '50%' : 1,
        showEdit: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          style = _this$props.style,
          prefixCls = _this$props.prefixCls,
          className = _this$props.className,
          editProps = _this$props.editProps,
          codePenOption = _this$props.codePenOption,
          codeSandboxOption = _this$props.codeSandboxOption,
          code = _this$props.code,
          dependencies = _this$props.dependencies,
          btnText = _this$props.btnText,
          btnHideText = _this$props.btnHideText,
          onlyEdit = _this$props.onlyEdit,
          bordered = _this$props.bordered,
          noCode = _this$props.noCode,
          noPreview = _this$props.noPreview,
          noScroll = _this$props.noScroll,
          bgWhite = _this$props.bgWhite,
          otherProps = (0, _objectWithoutProperties2.default)(_this$props, _excluded2);
      var isOneItem = !noCode && !noPreview ? false : !noCode || !noPreview;
      var visiable = this.state.width === 1 ? false : [isOneItem ? 1 : 2];
      return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_reactSplit.default, (0, _objectSpread2.default)((0, _objectSpread2.default)({
        visiable: visiable,
        className: [className, prefixCls, noScroll ? "".concat(prefixCls, "-noScroll") : null, isOneItem ? "".concat(prefixCls, "-OneItem") : null, bordered ? "".concat(prefixCls, "-bordered") : null, this.state.fullScreen ? "".concat(prefixCls, "-fullScreen") : null].filter(Boolean).join(' ').trim(),
        style: (0, _objectSpread2.default)({
          flex: 1
        }, style)
      }, otherProps), {}, {
        children: [!noPreview && !onlyEdit && /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
          ref: this.demoDom,
          className: ["".concat(prefixCls, "-demo"), !bgWhite ? "".concat(prefixCls, "-demo-bgPlaid") : null, this.state.errorMessage ? "".concat(prefixCls, "-demo-error") : null].filter(Boolean).join(' ').trim(),
          style: (0, _objectSpread2.default)({
            flex: 1
          }, this.state.width === 1 ? {
            width: '100%'
          } : {}),
          children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_ErrorMessage.ErrorMessage, {
            message: this.state.errorMessage
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
            className: ["".concat(prefixCls, "-demo-source"), this.state.errorMessage ? 'error' : null].filter(Boolean).join(' ').trim(),
            id: this.playerId
          })]
        }), (!noCode || onlyEdit) && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          style: {
            overflow: 'hidden',
            width: onlyEdit ? '100%' : this.state.width
          },
          children: (this.state.showEdit || onlyEdit) && /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactCodemirror.default, (0, _objectSpread2.default)((0, _objectSpread2.default)({
            value: (this.props.code || '').replace(/\n$/, ''),
            ref: this.editor,
            extensions: [(0, _langJavascript.javascript)({
              jsx: true
            })]
          }, editProps), {}, {
            style: {
              height: '100%'
            },
            height: "100%",
            onChange: this.handleChange.bind(this)
          }))
        }), !isOneItem && !(noCode && noPreview) && !onlyEdit && /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
          style: {
            flex: 1,
            width: 29
          },
          className: "".concat(prefixCls, "-bar"),
          children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_ThirdPartyButton.default, {
            prefixCls: prefixCls,
            codePenOption: codePenOption,
            codeSandboxOption: codeSandboxOption
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
            className: "".concat(prefixCls, "-bar-btn"),
            onClick: this.onSwitchSource.bind(this),
            children: this.state.width === 1 ? btnText : btnHideText
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
            className: ["".concat(prefixCls, "-bar-iconbtns"), this.state.copied ? "".concat(prefixCls, "-bar-copied") : null].filter(Boolean).join(' ').trim(),
            onClick: this.onCopyCode.bind(this),
            children: icon.copy
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
            className: ["".concat(prefixCls, "-bar-iconbtns"), this.state.fullScreen ? "".concat(prefixCls, "-bar-copied") : null].filter(Boolean).join(' ').trim(),
            onClick: this.onFullScreen.bind(this),
            children: icon.full
          })]
        })]
      }));
    }
  }]);
  return CodePreview;
}(_react.default.PureComponent);

exports.default = CodePreview;
(0, _defineProperty2.default)(CodePreview, "defaultProps", {
  prefixCls: 'w-code-preview',
  code: '',
  btnText: 'Code',
  btnHideText: 'Hide Editor',
  editProps: {},
  dependencies: {},
  noCode: false,
  bgWhite: false,
  onlyEdit: false,
  noPreview: false,
  bordered: true
});
module.exports = exports.default;
//# sourceMappingURL=index.js.map